#version 330                                                                         
                                                                                     
layout(points) in;                                                                   
layout(points, max_vertices = 30) out;                                                                  
                                                

in float Type0[];
in vec3 Position0[];                                                                 
in vec3 Velocity0[];                                                                 
in float Age0[];                                                                     

out float Type1;                                                                                                                                 
out vec3 Position1;                                                                  
out vec3 Velocity1;                                                                  
out float Age1;                                                                 
                                                                                     
uniform float gDeltaTimeMillis;                                                      
uniform float gTime;                                                                                                            
uniform float gLifeTime;                                                                                          
                                                                                                              
                                                                                     
        
                                                               
void main()                                                                          
{                                                                                    
    float Age = Age0[0] + gDeltaTimeMillis;         
	                      
    Type1 = 1.0f;
	Velocity1 = Velocity0[0].xyz*0.90;                                                                                                            
    Position1 =Position0[0]+ Velocity1;                                                                                                                 
    Age1 = Age;             
    if(Age <gLifeTime)                                              
    {
		EmitVertex();                                                            
	}
    EndPrimitive();   
	                                                                                                                                                                                              
}                                                                               