// Vertex Shader

#version 330 core

layout(location = 0) in vec3 in_position;
layout(location = 1) in vec2 in_tex;

uniform vec2 scale_down;

out vec2 tex;

void main(void)
{
	tex = in_tex;
	
	gl_Position = vec4(in_position*vec3(scale_down, 1.0), 1.0);
}
